# TODO

## audio

- [ ] gremlins arrived after dynamically toggling DSP for cloned grains. Not sure whether it's voice stealing or the dsp catching up or something.
    - the dips that sound like a grain is missing aren't voice stealing; the counter doesn't log it.
    - so I think we've got **dips**, **glitches**, and **repeated grains**
    - the **dips** might be phase issues (definitely some phasing weirdness going on)
    - **repetitions** could be from retrying the same grain a bunch of times
    - **glitches** are almost definitely from misaligned dsp toggle
        - except that they happen even without the DSP toggle engaged
    - the thing that would address most of these is changing the DSP toggle strategy from the inaccurate timer to analysing the envelope.
    - there are definitely windows getting cut off early on the scope
    - adding 2ms buffer to end of DSP timer fixes window issue still some gremlins but they seem to be in line with the phasing, kind of? could they be related?
        - verified window is no longer an issue (via DC offset test)
        - pretty sure **dips** are from phasing against a sine input -- they don't happen when buffer is frozen
        - repeated grains _might_ still be happening?
        - glitches could be from below:
- [ ] circular mode is borked? glitches still exist at certain points in the buffer
    - it _is_ doing something
    - could be that the grains are crossing the loop point from the record head, which circ mode isn't intended to deal with -- should it be? maybe. it doesn't know about the delay value, which is sent to circ-buff, but we don't know about the variation value. maybe delay should be variation + delay?
    - ugh yeah it needs to be done manually outside of grains. **there should be a note in the readme,** and a future version should take care of this for the user.


## performance

- [x] don't recalculate window size every grain `[pd window-size]`
- [x] don't recalculate table size every grain `[pd table-size]`
    - for both of these, only update when the table changes
- [ ] window table is still a bit wonky: doesn't update on DSP toggle because it's possibly set internally. should fix this. I think it's partly set in play-sample.pd and partly in grains~.pd.

## grains~

- [ ] duration subpatch: wrap to restore decimal precision doesn't work

* sensible defaults 
    * should be able to load a sample, hit play, and hear sound
    * shouldn't be exotic, eg, variation should be 0, sample plbk rate should be 1, etc
√ double check math - some combinations sound like playback rate is incorrect
× better sample playback rate change implementation, maybe?
√ enable reverse sample playback, maybe?
√ don't change params during already-playing grains
√ fix weird fadeouts and pops when changing rate
√ [fine] has different precisions & shows them
√ some way of showing √ / preventing √ overlap max clipping
√ some kind of compression?
× use offset inlet for [tabread4~], maybe?
√ window types
√ timing random params (dispersion, tightness)
√ sample random params (dispersion, tightness)
√ better terms for random params (range, intensity?)
√ "scatter" range should take ms not 0-1x
√ ramp windows maybe shouldn't click?
√ variation:
    √ grain duration variation?
    √ grain sample playback rate variation?
    √ use "variation" for timing, grain size, grain selection?
    √ "variation" currently means how likely a new value is to reach the max range. We should also have control over how likely a new value is to vary at all, which should be "probability".
    √ variation abstraction for consistency
√ bang in for a single grain
√ bang out logically before a grain
√ per-grain stereo dispersion
√ clearer API?
√ customizable polyphony?
* mixing window types?
√ assign wavetable name for window
√ assign wavetable name for sample
* ~~timing jitter delay cancels when sent a new value -- is this a problem?~~
    * it's never cancelled in this way; new values are queued by the delay they would need to cancel
    * two modes possible: _sequential_ (current, single delay, longer interval inserted in stream) and _deviant_ (variation is from otherwise regular pulse; longer interval does not interrupt underlying pulse; two delays required)
√ per-grain amplitude (primarily for variation)
    √ should be in db
√ pan needs rethinking
    √ currently sums to mono
    √ introduce pre-width (or sim) concept
√ mono signals in R work but not in L

## Interface
√ smooth buffer handover when recording new sample
* normalize recorded samples as option
√ sample rate of imported audio
√ change table size to accommodate entire incoming sample?

√ better controls
√ better interface (can we display the sample, playhead, scatter range? window?)
√ playhead modes (ping-pong, reverse)
* redo playhead math
    √ rate should work when start and end are set
    √ start and end shouldn't scale position (ie, should be able to change start & end without modifying plhd position)
    * playhead shouldn't jump when changing direction
    * changing playhead limits always restarts playhead
    * changing playhead limits might cause glitches?
√ option to keep duration, rate, tukey-sustain locked for seamless playback


## Other abstractions

* static sampler / sample-loader
√ continuous / "live" / Clouds-style continuous buffer sampler
* playhead for static buffer

## Housekeeping
√ remove dependencies on dried-utils
√ vanilla compatibility
* proper helpfile
* publish
